// FFSubmenu=Mikroskop
// FFName=My_Balken
// FFPath=My_Balken.js


/*
Das Script fgt einen Mastab (m-Balken) in das aktuelle Bild ein.
Fragt nach einem Bildnamen. Speichert das Bild ab.
Und legt eine INF Datei mit den Kalibrierungseinstellungen an.
Bild und INF Datei werden im aktuellen Arbeitsverzeichnis gespeichert.
Gltig fr das ZEISS Axioplan
(c) Diemartos im Mrz 2007
*/

var SS_CENTER = 1;
var Balkenlaenge = 0;
var Balkentext = "0.0 m";
var Pfad="C:\\temp\\"
var DName="-"
var Skalierung="0.0"
var fso, f;

fso=new ActiveXObject("Scripting.FileSystemObject");


// Anfang Main Programm

// Start Dialog Vergrerung
FF_AddDialog ("ZEISS Vergrerung",100,120);
FF_AddControl ("ZEISS Vergrerung","12.5 x","BUTTON",15,10,33,11);
FF_AddControl ("ZEISS Vergrerung","25 x","BUTTON",15,25,33,11);
FF_AddControl ("ZEISS Vergrerung","50 x","BUTTON",15,40,33,11);
FF_AddControl ("ZEISS Vergrerung","100 x","BUTTON",15,55,33,11);
FF_AddControl ("ZEISS Vergrerung","200 x","BUTTON",15,70,33,11);
FF_AddControl ("ZEISS Vergrerung","500 x","BUTTON",15,85,33,11);
FF_AddControl ("ZEISS Vergrerung","1000 x","BUTTON",15,100,33,11);
// ** Ende Dialog Vergrerung **

Knopf = FF_ShowDialog("ZEISS Vergrerung");
// FF_MessageBox("gedrckt=" + Knopf, 0);
FF_CloseDialog("ZEISS Vergrerung");

switch(Knopf) {
	case "12.5 x": { Balkenlaenge=1000/2.67; Balkentext = "1000 m"; Skalierung="2.67"; break; }
	case "25 x": { Balkenlaenge=500/1.324; Balkentext = "500 m"; Skalierung="1.324";  break; }
	case "50 x": { Balkenlaenge=200/0.6917; Balkentext = "200 m"; Skalierung="0.6917";  break; }
	case "100 x": { Balkenlaenge=100/0.3472; Balkentext = "100 m"; Skalierung="0.3472";  break; }
        case "200 x": { Balkenlaenge=50/0.1734; Balkentext = "50 m"; Skalierung="0.1734";  break; }
	case "500 x": { Balkenlaenge=20/0.06917; Balkentext = "20 m"; Skalierung="0.06917";  break; }
	case "1000 x": { Balkenlaenge=10/0.03479; Balkentext = "10 m"; Skalierung="0.03479";  break; }
}  //Ende switch(Knopf)

if (Knopf=="CANCEL") { FF_MessageBox("Abbruch durch den Anwender !" , 0); }
	else {
                    Balken(Balkenlaenge , Balkentext);

                    DName = InputBox("Bitte Bildname eingeben!", "Bildname", "");
					Pfad = FF_GetImagePath() + "\\"

                    // Die *.inf Datei mit dem Skalierungsfaktor erzeugen
                    f = fso.CreateTextFile(Pfad + DName + ".inf" , true);
                    f.WriteLine("[Meas]");
                    f.WriteLine("Unit=m");
                    f.WriteLine("Scale=" + Skalierung);
                    f.Close();

		    // Bild speichern und re-importieren damit das Vermessentool die korrekte Skalierung hat
                    FF_SaveImage(Pfad + DName + ".jpg", 90); // JPEG-Qualitt=90
                    FF_SetDirty(false); // diese Befehl mu direkt nach dem SaveImage und vor dem ImportImage stehen
                    FF_ImportImage(Pfad + DName + ".jpg");

             }

// Ende Main Prog


function InputBox(title,window,preset)
	{
	var text;
	FF_AddDialog(window,150,44);
	FF_AddControl(window,title,"STATIC",4,2,142,12);
	FF_SetControlStyle(window,title,SS_CENTER);
	FF_AddControl(window,"text","SLEDIT",4,14,142,10);
	FF_SetControl(window,"text",preset);
	FF_AddControl(window,"OK","BUTTON",4,28,40,12);
	FF_AddControl(window,"Abbrechen","BUTTON",106,28,40,12);
	FF_ActivateControl(window,"text");
	for(;;)
		{
		switch(FF_ShowDialog(window))
			{
			case "OK":	text = FF_GetControl(window,"text");
						if(text != "") {FF_CloseDialog(window); return text;}
						break;
			default:	FF_CloseDialog(window); return "";
			}
		}
	}


function Balken(L , Text1)
         {
          var Y;
          var XL;
          var XR;
          var Weiss=0xffffff;    // = Wei in HEX Blau Grn Rot NICHT RGB
          var Schwarz=0x000000;  // = Schwarz in HEX Blau Grn Rot
          var Abstand = FF_GetImageWidth()*0.01;  // Abstand der weien Flche vom Bildrand

          // weien Hintergrund zeichnen
          Y  = FF_GetImageHeight() - Abstand*4.5;
          XR = FF_GetImageWidth() - Abstand*2;
          XL = XR - L - Abstand*2;
          for (i = 0; i <= Abstand*3.5; i++)
              {
                 FF_HLine(  XL , XR , Y+i , Weiss);
              }
          // ENDE weien Hintergrund zeichnen

          // Schwarzen Balken zeichnen
          Y  = FF_GetImageHeight() - Abstand*2;
          XR = FF_GetImageWidth() - Abstand*3;
          XL = XR - L;
          for (i = 0; i <= Abstand/4; i++)
              {
                 FF_HLine(  XL , XR , Y+i , Schwarz); // = Schwarz
              }
          // ENDE Schwarzen Balken zeichnen

          FF_TextAlign(8);   // der Startpunkt ist Unten Links definiert
          var Schrifthoehe = Abstand*2;  // Text Grsse
          var Schriftart = "Arial";
          var Schriftstaerke = 700;  // die Schriftstrke (0-1000), 400 ist Normal
          var Winkel = 0;
          var Kursiv = false;
          var Unterstrichen = false;
          XStart = FF_GetImageWidth() - FF_GetTextWidth(Text1, Schrifthoehe , Schriftstaerke, Kursiv, Unterstrichen, Schriftart)/2 - Abstand*3 -L/2;
          YStart = FF_GetImageHeight() - Abstand*2.25;
          FF_DrawText(Text1 , XStart , YStart, Schrifthoehe , Winkel , Schriftstaerke, Kursiv, Unterstrichen, Schriftart, Schwarz);

         } // ENDE function Balken

